c234567----------------------------------------------------------------|
      program tmat
      implicit none
c definisco due costanti nrow, ncol e dichiaro (alloco) matrice A
      integer nArow,nAcol
      integer nBrow,nBcol
      integer nCrow,nCcol

      parameter( nArow = 3 , nAcol = 5 )
      parameter( nBrow = 5 , nBcol = 2 )
      parameter( nCrow = 3 , nCcol = 2 )

      real A(nArow,nAcol)
      real B(nBrow,nBcol)
      real C(nCrow,nCcol)

c definisco due indici per scorrere le matrici, più uno di sommatoria
      integer irow,icol,isum,nsum

c---- fine dichiarazioni ----------------------------------------------|
c---- inizio istruzioni -----------------------------------------------|

c INPUT matrice A da standard input (stdin)
      do irow = 1,nArow
       read(*,*) ( A(irow,icol), icol=1,nAcol )
      enddo

c INPUT matrice B da standard input (stdin)
      do irow = 1,nBrow
       read(*,*) ( B(irow,icol), icol=1,nBcol )
      enddo
c---- qui calcolo il prodotto ----

      call prodmat(nArow,nAcol,nBcol,A,B,C)

c---- qui calcolo il prodotto ----

c OUTPUT matrice C su stdout
      do irow = 1,nCrow
        write(*,*) ( C(irow,icol), icol=1,nCcol )
      enddo      

      stop
      end




      subroutine prodmat(nAArow,nAAcol,nBBcol,AA,BB,CC) 
      implicit none
c     === INPUT ===
c     dimensionamento matrici per prodotto
      integer nAArow, nAAcol, nBBcol
c     matrici per prodotto
      real AA( nAArow, nAAcol )
      real BB( nAAcol, nBBcol )
c     === OUTPUT ===
c     matrice su cui scrivere il risultato del prodotto
      real CC( nAArow, nBBcol )
c     === IN/OUT , UPDATE, MODIFICA ... ===
c     area dedicata a variabili a cui si accede in INPUT/OUTPUT

c     === variabili locali ===
c dichiaro indici di scorrimento riga/colonna su CC e di sommatoria
      integer irow, icol, isum

c ----- fine dichiarazioni
c ----- inizio istruzioni

      do irow = 1,nAArow
       do icol = 1, nBBcol
        CC(irow,icol)= 0.0
        do isum = 1, nAAcol
         CC(irow,icol)=CC(irow,icol) + AA(irow,isum)*BB(isum,icol)
        enddo
       enddo
      enddo 

      return
      end

